/*
 * tests/elv/Kernel.c - Fake kernel environment
 *
 * Written 2004-2005 by Werner Almesberger
 *
 * (C) Copyright Koninklijke Philips Electronics NV 2004-2005. All rights
 * reserved.
 *
 * For licensing and warranty information, see the file ../../COPYING.GPLv2
 */

/*
 * DO NOT #include "Kernel.h"
 */

#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>

#include "Kglue.h"


int no_printk = 0;


void *kmalloc(size_t size,int gfp_mask)
{
	return malloc(size);
}


void kfree(void *ptr)
{
	free(ptr);
}


long simple_strtol(const char *p,char **end,int base)
{
	return strtol(p,end,base);
}


unsigned long simple_strtoul(const char *p,char **end,int base)
{
	return strtoul(p,end,base);
}


int scnprintf(char *buf,size_t size,const char *fmt,...)
{
	va_list ap;
	size_t len;

	va_start(ap,fmt);
	len = vsnprintf(buf,size,fmt,ap);
	va_end(ap);
	return len > size ? size : len;
}


void BUG(void)
{
	abort();
}


int printk(const char *fmt,...)
{
	va_list ap;
	int n;

	if (no_printk)
		return n;
	va_start(ap,fmt);
	n = vprintf(fmt,ap);
	va_end(ap);
	return n;
}


void panic(const char *fmt,...)
{
	va_list ap;

	va_start(ap,fmt);
	vprintf(fmt,ap);
	va_end(ap);
	fflush(stdout);
	abort();
}
